#!/usr/bin/env python

# This file is directly borrowed from vsphere-2015-vsanhealth branch

import os
import re

__all__ = ["VsanAsyncSystem", "VsanAsyncSystemImpl"]

localdir = os.path.dirname(__file__)

# Discover more managed objects to include by scanning files in current
# directory and look for file name like "<Feature>__ext_init__.py(c)"
__ext_file_regexp__ = "(.+)__ext_init__\.py(c?)$"
extensions = set()
for file in os.listdir(localdir):
   if os.path.isfile(os.path.join(localdir, file)):
      result = re.search(__ext_file_regexp__, file)
      if result:
         extensions.add(result.groups()[0] + '__ext_init__')
__all__.extend(extensions)


# Import __all__
for name in __all__:
   __import__(name, globals(), locals(), [], 1)
